<?php
namespace App\Http\Controllers;
use Illuminate\Hashing\BcryptHasher;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use App\Menu;
use Carbon\Carbon;

class MenuController extends Controller
{

    public function getRecords($id='')
    {
        //return $request->all();
        if($id > 0){

            return Menu::find($id);
        }
        return Menu::where('status', '!=', '0')->paginate(10);
    }

    public function create(Request $request)
    {
        //creating a validator
        $validator = Validator::make($request->all(), [
            'menu_name' => 'required',
            'menu_alias' => 'required',
            'menu_icon' => 'required',
            'menu_ishome' => 'required'
        ]);

        //if validation fails
        if ($validator->fails()) {
            return array(
                'error' => true,
                'message' => $validator->errors()->all()
            );
        }

        //creating a new menu
        $menu = new Menu();
        //return $request->all();
        //adding values to the menu table
        $menu->title = $request->menu_name;
        $menu->alias = $request->menu_alias;
        $menu->parent_id = $request->menu_category;
        $menu->view = $request->menu_view;
        $menu->icon = $request->menu_icon;
        $menu->is_home = $request->menu_ishome;
        $menu->ordering = $request->menu_ordering;
        //saving the menu to database
         if($request->id > 0){
            $item = $menu->findOrFail($request->id);
            if($item){
                $modification_date =  Carbon::now();

                 $menu->where('id', $request->id)->update(['title'=>$menu->title,'alias'=>$menu->alias, 'view'=>$menu->view,'icon'=>$menu->icon, 'is_home'=>$menu->is_home, 'ordering'=>$menu->ordering, 'modification_date'=>$modification_date]);

                return array('error' => false, 'menu' => 'Menu Updated successfully');
            }
        }

        $menu->save();

        //returning the added menu
        return array('error' => false, 'menu' => 'Menu added successfully');
    }

    public function getParentCategory($id=''){
            if($id > 0){

                return Menu::find($id);
            }
         return Menu::where('parent_id', '=', 0)->get();
    }
    public function delete(Request $request)
    {
        $menu = Menu::findOrFail($request->menu_id);
        if($menu){
           $menu->where('id', $request->menu_id)->update(['status'=>'0']);
            return array('error' => false, 'menu' => 'Menu deleted successfully');
        }else{
         return array('error' => true, 'menu' => 'Error: Unable to delete menu Record!');
        }
    }

}