<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class Billing extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('billing', function(Blueprint $table)
        {
            $table->increments('id');
            $table->char('patient_id', 36);
            $table->integer('appointment_id')->unsigned();
            $table->integer('print_id');
            $table->integer('doctor_id');
            $table->float('total_medicine_cost', 8, 2);
            $table->integer('consultancy_fees');
            $table->float('waive_consultancy_fees', 8, 2);
            $table->float('waive_pending_amount', 8, 2);
            $table->float('discount_before_med_cost', 8, 2);
            $table->float('discount_after_med_cost', 8, 2);
            $table->integer('discount_on_med');
            $table->float('total_billing_cost', 8, 2);
            $table->float('tax_amount', 8, 2);
            $table->string('pharmacy_instruction', 225);
            $table->integer('created_by');
            $table->timestamp('creation_date');
            $table->integer('modified_by');
            $table->timestamp('modification_date');
            $table->enum('status', ['0', '1', '2'])->default(1);
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('billing');
    }
}
