<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateChargetable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
	public function up()
	{
	   Schema::create('charges', function (Blueprint $table) {
			$table->increments('id');
			$table->string('charge_type', 250);
			$table->integer('charge_cost');
			$table->string('charge_code', 3)->unique();
			$table->text('description');
			$table->boolean('doctor_related');
			$table->integer('created_by');
			$table->timestamp('creation_date_on');
			$table->integer('modified_by');
			$table->timestamp('modification_date');
			$table->enum('status', ['0', '1', '2'])->default(1);
		});
	}

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('charges');
    }
}
