<?php
use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;
class BillingPatientCharge extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('billing_patient_charge', function(Blueprint $table)
        {
            $table->increments('id');
            $table->char('patient_id', 36);
            $table->integer('appointment_id')->unsigned();
            $table->integer('billing_id')->unsigned();
            $table->float('charge_amount', 8, 2);
            $table->string('charge_name', 200);
            $table->integer('created_by');
            $table->timestamp('creation_date');
            $table->integer('modified_by');
            $table->timestamp('modification_date');
            $table->enum('status', ['0', '1', '2'])->default(1);
            $table->foreign('billing_id')->references('id')->on('billing');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('billing_patient_charge');
    }
}
