<?php
use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;
class PatientDiscount extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('patient_discount', function(Blueprint $table)
        {
            $table->increments('id');
            $table->integer('appointment_id')->unsigned();
            $table->integer('billing_id')->unsigned();
            $table->float('discount_before_med_cost', 8, 2);
            $table->float('discount_after_med_cost', 8, 2);
            $table->integer('discount_on_med');
            $table->integer('created_by');
            $table->timestamp('creation_date')->useCurrent();
            $table->integer('modified_by');
            $table->timestamp('modification_date')->default('0000-00-00 00:00:00')->useCurrent();
            $table->enum('status', ['0', '1', '2'])->default(1);
            $table->foreign('billing_id')->references('id')->on('billing')->onDelete('cascade');
        });
    }
    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('patient_discount');
    }
}
