<?php
namespace App\Modules\Instruction\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Validation\ValidationException;
use Illuminate\Support\Facades\Validator;
use App\Modules\Instruction\Models\Instruction;
use Carbon\Carbon;
class InstructionController extends Controller
{
    public function create($id='',Request $request){
        $validator = Validator::make($request->all(), [
            'instruction_name' => 'required',
            'status' => 'required'
        ]);
        //if validation fails
        if ($validator->fails()) {
            return array(
                'error' => true,
                'message' => $validator->errors()
            );
        }
 try{
        $instruction = new Instruction();
        $instruction->instruction_name = $request->instruction_name;
        $instruction->status = $request->status;
        //this below conditional block is used for update records in database 
     if((isset($request->id)) && ($request->id > 0)){
             try{
                    //for Medicine data
                    $item = $instruction->findOrFail($request->id);
                        if($item){
                            $modification_date =  Carbon::now('Asia/Kolkata');
                            $instruction->where('id', $request->id)->update(['instruction_name'=>$instruction->instruction_name, 'status'=>$instruction->status, 'modification_date'=>$modification_date]);
                            $res['error'] = false;
                            $res['actions'] = 'update';
                            return response($res, 200);
                        }
                }catch(\Illuminate\Database\QueryException $ex){
                    $res['status'] = false;
                    $res['message'] = $ex->getMessage();
                    return response($res, 500);
                } 	
            }else{
                    $instruction->save();
                    $res['error'] = false;
                    $res['actions'] = 'add';
                    return response($res, 200);
                      
            }
    
        }catch(\Illuminate\Database\QueryException $ex){
            $res['status'] = false;
            $res['message'] = $ex->getMessage();
            return response($res, 500);
        } 	
    }

    public function getRecords($id='',Request $request){
            /*This below condition is used for distinguish edit form request, In this case we get details of perticular instruction */
            if($id > 0){
                
                return Instruction::find($id);
            }
             /*This below condition is used for distinguish getting all data list form request, */
            if($request->has('datalist')){

                return Instruction::where('status','=', ['1','3'])->orderBy('id', 'DESC')->get();

            }
            return Instruction::where('status','=', ['1','2'])->orderBy('id', 'DESC')->get();
    }

    //  Delete Record for particular instruction id
        public function delete(Request $request)
        {
            $instruction = Instruction::findOrFail($request->instruction_id);
            try{
                if($instruction){

                        $instruction->where('id', $request->instruction_id)->update(['status'=>'0']);
                        $res['error'] = false;
                        return response($res, 200);
                }else{
                        $res['error'] = true;
                        return response($res, 401);
                }
            }catch(\Illuminate\Database\QueryException $ex){
                $res['status'] = false;
                $res['message'] = $ex->getMessage();
                return response($res, 500);
            }
        }
}
