<?php

namespace App\Modules\Medicine\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Validation\ValidationException;
use Illuminate\Support\Facades\Validator;
use App\Modules\Medicine\Models\form; 
use App\Modules\Medicine\Models\potency; //import potency model 
use App\Modules\Medicine\Models\potencygroup; //import potencygroup model 
use App\Modules\Medicine\Models\pricegroup; //import potencygroup model 
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use Illuminate\Validation\Rule;

class PotencyController extends Controller
{
     public function create($id='',Request $request){
	
		$id = 0;
        if($request->id > 0 ){
            $id = $request->id;
		 }
		 $name=  $request->name;
		 $dilution_code=  $request->dilution;
//In this below validation code we have added the custom code for making the unique combination of potency name and dilution, Rahul khan, 05/Aug/2019
		$validator = Validator::make($request->all(), [
			'dilution' => 'required',
			'pricegroup' => 'required',
			'name' => 'required',
			'status' => 'required',
			'ordering' => [
					Rule::unique('potencies')->where(function ($query) use($id,$name,$dilution_code) {
						$query->where('status','!=','0')->where('id','!=',$id)->where('name',$name)->where('dilution',$dilution_code);
					}),
			],
		]);
	
		if ($validator->fails()) {
			return array(
				'error' => true,
				'message' => $validator->errors()
			);
		}
		//return false;
		$potency = new potency();
		$potencygroup = new potencygroup();
		
		$potency->name = $request['name'];
		$potency->dilution = $request['dilution'];
		$potency->status = $request['status'];
		
		//this below conditional block is used for update records in database 
		if((isset($request->id)) && ($request->id > 0)) {
			$id = $request->id;
		   // return $id;
			$item = $potency->findOrFail($id)->where('status','!=','0');
			if($item){
				$modification_date =  Carbon::now('Asia/Kolkata');
				$potency->where('id', $id)->update(['name'=>$request['name'],'dilution'=>$request['dilution'],'status'=>$request['status'],'modification_date'=>$modification_date]);
				$potencygroup->where('potency_id', $id)->delete();

				foreach($request->pricegroup as $pricegroup){
                        $potencygroup->create(['pricegroup_id'=>$pricegroup,'potency_id'=>$request->id]);
				}
				return array('error' => false, 'potency' => 'Potency added successfully');
			}
		}else{
			
			$potency->save();
			$potency_id =  $potency->id;
			foreach($request->pricegroup as $pricegroup){
                    $potencygroup->create(['pricegroup_id'=>$pricegroup,'potency_id'=>$potency_id]);
				}
			return array('error' => false, 'potency' => 'Potency added successfully');
		}
	}
    public function getRecords($id='',Request $request){
        //return $request->search;
        $potency = new potency();
        /*This below condition is used for distinguish edit form request, In this case we get details of perticular price group */
        if($id > 0){
			
			$priceGroup =  $potency->find($id);
			$potencyGroup =  $potency->find($id)->getPotencyGroup;
			
			//return $priceGroup;
			$formValue = array();
			foreach($potencyGroup as $key=>$group){
				$groupDetails = pricegroup::find($group['pricegroup_id'],['name','status']);
				$group["name"] = $groupDetails['name'];
				if($groupDetails['status']==1){
					array_push($formValue, $group);
				}
				/*This Below line of code is added for  */
				/* $priceGroup =  $potency->find($id);
				return $priceGroup;
				//return $priceGroup;
				//return $form_detail;
				$formName[$rate->form_code] = $form_detail->name;
				$formName[$rate->form_code.'_'.'rate'] = $rate->rate;
				
				$formName['status'] = $rate->status;
				$formName['name'] = $priceGroup->name;
				$formName['description'] = $priceGroup->description; */
				//$rate['form_name'] = $form_detail->name;
				 //$formName['form_name'] = $form_detail->name;
				//$formName['test'] = $form_detail['name'];
				//$priceRate[$form_detail->form_code] = $form_detail->name;
				
			}
		$priceGroup['potencyGroup'] = $formValue;
		return $priceGroup;
        }
        /*This below condition is used for distinguish search form request, */
        if($request->has('search')){
            return $potency->where('name', 'LIKE', '%' . $request->search . '%')->where('status','!=','0')->paginate(10);
        }
        /*This below condition is used for distinguish getting all data list form request, */
        if($request->has('datalist')){
            return $potency->where('status','!=','0')->get();
        }
        //   return array('error' => false, 'data' => 'Price Group Updated successfully');
        return $potency->where('status','!=','0')->paginate(10);
    }

    public function deleteRecords($id=''){
        // return  $id;
      $pricegroup = new potency();
      $pricegroup->where('id', $id)->update(['status'=>'0']);
      return array('error' => false, 'potency' => 'Potency Deleted successfully');
      //;
  }
}
