<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class UserBranchMap extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('user_branch_map', function (Blueprint $table){
            $table->increments('id');
            $table->integer('user_id');
            $table->integer('branch_id');
            $table->integer('kiosk')->default('1');
            $table->integer('maximum_token_number')->default('50');
            $table->integer('created_by');
            $table->timestamp('creation_date');
            $table->integer('modified_by');
            $table->timestamp('modification_date');
            $table->index(['user_id', 'branch_id'], 'user_id'); 
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('user_branch_map');
    }
}
