<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateClBranchesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('cl_branches', function (Blueprint $table) {
            $table->increments('id');
            $table->string('title', 250);
            $table->string('branch_code', 10);
            $table->integer('city_id')->unsigned()->nullable()->defaut(null);
            $table->integer('state_id')->unsigned()->nullable()->defaut(null);
            $table->integer('country_id')->unsigned()->nullable()->defaut(null);
            $table->string('fullname', 250);
            $table->integer('ordering');
            $table->integer('created_by');
            $table->timestamp('creation_date_on');
            $table->integer('modified_by');
            $table->timestamp('modification_date');
            $table->enum('status', ['0', '1', '2']);
            $table->index(['city_id', 'country_id'], 'city_id');
            $table->index(['state_id'], 'state_id');
            $table->index(['country_id'], 'country_id');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('cl_branches');
    }
}
